//+------------------------------------------------------------------+
//|                                                OrderFunction.mq4 |
//|                                                    Zhukov Sergey |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Zhukov Sergey"
#property link      "sergjuca@yandex.ru"
#property library
#property version   "1.03"
#property strict

//--------------------------------------------------------------- 2 --
#include <stdlib.mqh>
#include <stderror.mqh>
#include <WinUser32.mqh>

  //void iOpenOrder(string Simb,string Comm, int Magic, int Bay_Sell,double Lots, double stoploss, double profit);
  //int iCloseOrder(string Symb, string Comm,int Magic,int Bay_Sell);
  //int iFindOrder(string Symb, string Comm,int Magic,int Bay_Sell);
  //int iCountOrder(string Symb, string Comm,int Magic,int Bay_Sell);
  //void iDeleteStopOrder(string Symb, string Comm,int Magic,int Bay_Sell);
  //int iModifyStopOrder(string Symb, string Comm,double Price,double StopLoss, double Profit, int Magic,int Bay_Sell);
  //int iModifyStopLoss( int ticket,string Symb, string Comm, double StopLoss,int Magic, int Bay_Sell)export
  //double iProfit_calculate(string Symb,int digit, double profit);
  //double iStoploss_calculate(string Symb,int digit, double stoploss); 
  
  
 #import "FileFunction.ex4"
   void fSaveOrder(datetime date, int ticket, string Simb,string Comm, int Magic, string Bay_Sell,double Lots, double price,double stoploss, double profit);
 #import   
//+------------------------------------------------------------------+
//|                                    |                     |
//+------------------------------------------------------------------+
 void iOpenOrder(string Simb,string Comm, int Magic, int Bay_Sell,double Lots, double stoploss, double profit)export
 {
 
 //----------------------     -------------------
 int money;
 string text;
 color arrow_color=0;
 double   SL=0 ;
 double  TP=0;
 double  price=0; 
 string type;
 text=TerminalCompany();
 if (text=="MFX Broker Inc.") money=8000;
 else money=80;
 switch(Bay_Sell)                        //   
        {
         case OP_BUY :
            text="Buy ";                 //   Buy
            arrow_color=Green;
            break;                              //  switch
         case OP_SELL: 
            text="Sell ";                       //   Sell
            arrow_color=Red;
         }
 if (AccountFreeMarginCheck(Simb,Bay_Sell,Lots)< money || GetLastError()==ERR_NOT_ENOUGH_MONEY)
   {   
   Print("       ", Simb, ", ",Comm," ",text);
   return ;
   }
 if(OrdersTotal()>=8) 
    {
    Print("   . - ", OrdersTotal(),", - ",5,"; ",Simb, ", ",Comm," ",text);
    return ;
    }  
//------------------------------------------------------------------------- 
int i;// 
i=1;

while(true)                                 //   .
 {
 switch(Bay_Sell)               //    
               {
               case OP_BUY :               
                  SL = NormalizeDouble(Ask-stoploss,Digits);
                  TP = NormalizeDouble(Ask+profit*Point,Digits);
                  price =Ask; 
                  type="buy";          
                  break;                              //  switch
               case OP_SELL: 
                  SL = NormalizeDouble(Bid+ stoploss,Digits);
                  TP = NormalizeDouble(Bid-profit*Point, Digits);
                  price=Bid; 
                  type="sell";          
                }
 
 Print("   ", i, "   .  ..");
 
 
 
 int ticket=OrderSend(Simb,Bay_Sell,Lots,price,3,SL,TP,Comm,Magic,0,arrow_color);
 
 if(ticket>-1)
     {
     if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)==true)
       {
       Print(text, " ",Simb, " ",Comm," order opened : ",OrderOpenPrice()); 
       //fSaveOrder( OrderOpenTime(), ticket, Simb, Comm, Magic, type,Lots, OrderOpenPrice(), OrderStopLoss(), OrderTakeProfit());
       }
     break;
     }
     else 
     {
     int Error=GetLastError();               //   :(
      switch(Error)                            //  
        {
         case 4 :Print("  . ...");
            while(RefreshRates()==false)  //   
            Sleep(500);                   //   
            continue;                     //  . 
         case 6 :Print("    . ...");
            while(RefreshRates()==false)  //   
            Sleep(2000);                  //   
            continue;                     //  . 
         case 132 :Print(" . ...");
            while(RefreshRates()==false)  //   
            Sleep(1000);                   //   
            continue;                     //  .  
         case ERR_TRADE_TIMEOUT :Print("    ");
            i++;
            if (i==6)
               { 
               Print("   ");
               break;
               }    
            RefreshRates();               //  
            continue;                     //  . 
         
         case 129 :Print(" . ...");
            while(RefreshRates()==false)  //   
            Sleep(50);                   //   
            continue;
         case 137 :Print(" . ...");
            while(RefreshRates()==false)  //   
            Sleep(500);                   //   
            continue;                     //  .             
         
         case 135:Print(" .   ..");
            i++;
            if (i==6)
               { 
               Print("   ");
               break;
               }    
            RefreshRates();               //  
            continue;                     //  . 
         case 138:Print(" .   ..");
            i++;
            if (i==4)
               { 
               Print("   ");
               break;
               }
            RefreshRates();               //  
            continue;                     //  . 
            
            case 136:Print(" .   ..");
            while(RefreshRates()==false)  //   
            Sleep(100);                  //   
            continue;                     //  . 
         } 
      switch(Error)                       //  
        {
         case ERR_NO_RESULT : Print(" ,   .");//code=1
            break;
         case ERR_COMMON_ERROR : Print(" .");//code=2
            break;                        //   switch
         case ERR_INVALID_TRADE_PARAMETERS : Print(" .");//code=3
            break;                        //   switch   
         case ERR_OLD_VERSION : Print("   .");//code=5
            break;                        //   switch
         case 64: Print(" .");
            break;                        //   switch
         case 133:Print(" ");
            break;                        //   switch
            
         default: Print("  ",Error);//    
        }
      break;                                    //               
     }
  }// while(true)   
 //--------------------------------------------------------------------    
 return;
 }
 
//+------------------------------------------------------------------+
//|                                                         |
//+------------------------------------------------------------------+
 int iCloseOrder(string Symb, string Comm,int Magic,int Bay_Sell)export 
 { 
    int Real_Order=-1;
    string Text="";
    double Profit=0;
    double Price_Cls=0;
    int Ticket=0;                //  
    double Lot=0; 
    int i;
    for(i=1; i<=OrdersTotal(); i++)         //   
      {
      if (OrderSelect(i-1,SELECT_BY_POS)==true) //   
        {                                      //  :
         //------------------------------------------------------ 3 --
        // if (OrderMagicNumber()!= Magic)     continue;    //   
         if (OrderSymbol()     != Symb)      continue;    //   ..
         if (OrderComment()    != Comm)      continue;    //   
         if (OrderType()       != Bay_Sell)  continue;  
                        
         //------------------------------------------------------ 4 --
         Real_Order=Bay_Sell;                     //   
         Ticket=OrderTicket();                //  
         Lot=OrderLots();                  //  
         Profit=OrderProfit();
         }                                        //         
      
      }                                           //  .                                       
     
  //--------------------------------------------------------------- 6 --
   while(true)                                 //   .
     {
      if (Real_Order==-1)                       //   
        {
        // Print(" ",Symb," ",Comm,"   ");
         break;                                 //            
        }
      //--------------------------------------------------------- 7 --
      switch(Real_Order)                        //   
        {
         case OP_BUY :
            Price_Cls=Bid;               //  Buy
            Text="Buy ";                 //   Buy
            break;                              //  switch
         case OP_SELL: 
            Price_Cls=Ask;                      //  Sell
            Text="Sell ";                       //   Sell
         }
      Print("  ",Text," ",Comm," ",Ticket,".  ..");  
      bool Ans=OrderClose(Ticket,Lot,Price_Cls,4,Green);//  
      //--------------------------------------------------------- 8 --
      if (Ans==true)                            //  :)
        {
         Print ("  ",Text," ",Comm," ",Ticket);
         i--;
         break;                                 //       
        }
      //--------------------------------------------------------- 9 --
      
      
      
      int Error=GetLastError();               //   :(
      switch(Error)                            //  
        {
         case 4 :Print("  . ...");
            while(RefreshRates()==false)  //   
            Sleep(500);                   //   
            continue;                     //  . 
         case 6 :Print("    . ...");
            while(RefreshRates()==false)  //   
            Sleep(500);                   //   
            continue;                     //  . 
         case 132 :Print(" . ...");
            while(RefreshRates()==false)  //   
            Sleep(1000);                   //   
            continue;                     //  .  
         case 137 :Print(" . ...");
            while(RefreshRates()==false)  //   
            Sleep(500);                   //   
            continue;                     //  .             
         case 129 :Print(" . ...");
            while(RefreshRates()==false)  //   
            Sleep(50);                   //   
            continue;
         case 135:Print(" .   ..");
            RefreshRates();               //  
            continue;                     //  . 
         case 138:Print(" .   ..");
            RefreshRates();               //  
            continue;
         case 136:Print(" .   ..");
            while(RefreshRates()==false)  //   
               Sleep(100);                  //   
            continue;                     //  . 
         case 146:Print("  .  ..");
            Sleep(500);                   //  
            RefreshRates();               //  
            continue;                     //  . 
         case ERR_TRADE_TIMEOUT :Print("    ");
            Sleep(50);
            RefreshRates();               //  
            continue;      
        }
      
      
      switch(Error)                       //  
        {
         case 2 : Print(" .");
            break;                        //   switch
         case 5 : Print("   .");
            break;                        //   switch
         case 64: Print(" .");
            break;                        //   switch
         case 133:Print(" ");
            break;                        //   switch
         default: Print("  ",Error);//    
        }
      break;                                    //    
     }      
       
    return (Real_Order);
   }
   
//+------------------------------------------------------------------+
//+    
//+------------------------------------------------------------------+
 int iFindOrder(string Symb, string Comm,int Magic,int Bay_Sell) export
   {
   int Real_Order=-1;
   int Ticket=-1;
   
    for(int i=1; i<=OrdersTotal(); i++)         //   
      {
      if (OrderSelect(i-1,SELECT_BY_POS)==true) //   
        {                                      //  :
         //------------------------------------------------------ 3 --
         //if (OrderMagicNumber()!= Magic)     continue;    //   
         if (OrderSymbol()     != Symb)      continue;    //   ..
         if (OrderComment()    != Comm)      continue;    //   
         if (OrderType()       != Bay_Sell)  continue;  
                        
         //------------------------------------------------------ 4 --
         Real_Order=Bay_Sell;                     //  
         Ticket=OrderTicket();                   //          
         break;
         }                                        //         
      
      }
     // if (Ticket<0) Print (" ",Comm,"  ");                                          //  .      
   return (Ticket);
   }
   
//+------------------------------------------------------------------+
//+        
//+------------------------------------------------------------------+
 double iFindOrderPrice(string Symb, string Comm,int Magic,int Bay_Sell) export
   {
   int Real_Order=-1;
   double Price=0;
   
    for(int i=1; i<=OrdersTotal(); i++)         //   
      {
      if (OrderSelect(i-1,SELECT_BY_POS)==true) //   
        {                                      //  :
         //------------------------------------------------------ 3 --
         //if (OrderMagicNumber()!= Magic)     continue;    //   
         if (OrderSymbol()     != Symb)      continue;    //   ..
         if (OrderComment()    != Comm)      continue;    //   
         if (OrderType()       != Bay_Sell)  continue;  
                        
         //------------------------------------------------------ 4 --
         Real_Order=Bay_Sell;                     //  
         Price=OrderOpenPrice();                  //           
         break;
         }                                        //         
      
      }
     // if (Ticket<0) Print (" ",Comm,"  ");                                          //  .      
   return (Price);
   }   
   
//+------------------------------------------------------------------+
//+     
//+------------------------------------------------------------------+
 int iCountOrder(string Symb, string Comm,int Magic,int Bay_Sell) export
   {
   int Real_Order=-1;
   int Ticket=-1;
   int Count = 0;
    for(int i=1; i<=OrdersTotal(); i++)         //   
      {
      if (OrderSelect(i-1,SELECT_BY_POS)==true) //   
        {                                      //  :
         //------------------------------------------------------ 3 --
         if (OrderMagicNumber()!= Magic)     continue;    //   
         if (OrderSymbol()     != Symb)      continue;    //   ..
         if (OrderComment()    != Comm)      continue;    //   
         if (OrderType()       != Bay_Sell)  continue;  
                        
         //------------------------------------------------------ 4 --
         Count++;
         //Real_Order=Bay_Sell;                     //  
         //Ticket=OrderTicket();                   //          
         
         }                                        //         
      
      }                                           //  .      
   return (Count);
   }   
//+------------------------------------------------------------------+
//|                                                          |
//+------------------------------------------------------------------+
 void iDeleteStopOrder(string Symb, string Comm,int Magic,int Bay_Sell)export
 { 
    int Stop_Order=-1; 
    int Ticket=-1;
    string Text="";
    int i;
      
    for( i=1; i<=OrdersTotal(); i++)         //   
      {
      if (OrderSelect(i-1,SELECT_BY_POS)==true) //   
        {                                      //  :
         //------------------------------------------------------ 3 --
         if (OrderMagicNumber()!= Magic)     continue;    //   
         if (OrderSymbol()     != Symb)      continue;    //   ..
         if (OrderComment()    != Comm)      continue;    //   
         if (OrderType()       != Bay_Sell)  continue;  
                        
         //------------------------------------------------------ 4 --
         Stop_Order=Bay_Sell;                     //   
         Ticket=OrderTicket();                   //  
         double Lot=OrderLots();                  //  
         }                                        //         
      
      }                                           //  .                                       
     
  //--------------------------------------------------------------- 6 --
   while(true)                                 //   .
     {
      if (Stop_Order==-1)                       //   
        {
         //Print(" ",Symb,Comm,"   ");
         break;                                 //            
        }
      //--------------------------------------------------------- 7 --
      switch(Stop_Order)                        //   
        {
         case OP_BUYSTOP: 
            Text="StopBuy ";                 //   Buy
            break;                              //  switch
         case OP_SELLSTOP:
            Text="StopSell ";                       //   Sell
         }
      Print("  ",Text," ",Comm," ",Ticket,".  ..");  
      bool Ans=OrderDelete(Ticket,Yellow);//  
      //--------------------------------------------------------- 8 --
      if (Ans==true)                            //  :)
        {
         Print ("  ",Text," ",Comm," ",Ticket);
         i--;
         break;                                 //       
        }
      //--------------------------------------------------------- 9 --     
      
      
      int Error=GetLastError();               //   :(
      switch(Error)                            //  
        {         
        
         case 146:Print("  .  ..");
            Sleep(500);                   //  
            RefreshRates();               //  
            continue;                     //  . 
        }
      switch(Error)                       //  
        {
         case 2 : Print(" .");
            break;                        //   switch
         case 5 : Print("   .");
            break;                        //   switch
         case 64: Print(" .");
            break;                        //   switch
         case 133:Print(" ");
            break;                        //   switch
         default: Print("  ",Error);//    
        }
      break;                                    //    
     }      
       
    return ;
   }
//+------------------------------------------------------------------+
//|                                                           |
//+------------------------------------------------------------------+
 int iModifyStopOrder(string Symb, string Comm,double Price,double StopLoss, double Profit, int Magic,int Bay_Sell)export
 { 
    int Stop_Order=-1; 
    int Ticket=-1; 
    string Text=""; 
    int i;
     
    for(i=1; i<=OrdersTotal(); i++)         //   
      {
      if (OrderSelect(i-1,SELECT_BY_POS)==true) //   
        {                                      //  :
         //------------------------------------------------------ 3 --
         if (OrderMagicNumber()!= Magic)     continue;    //   
         if (OrderSymbol()     != Symb)      continue;    //   ..
         if (OrderComment()    != Comm)      continue;    //   
         if (OrderType()       != Bay_Sell)  continue;  
                        
         //------------------------------------------------------ 4 --
         Stop_Order=Bay_Sell;                     //   
         Ticket=OrderTicket();                    //  
         double Lot=OrderLots();                  //  
         }                                        //         
       
      
      }                                           //  .                                       
     
  //--------------------------------------------------------------- 6 --
   while(true)                                 //   .
     {
      if (Stop_Order==-1)                       //   
        {
         //Print(" ",Symb," ",Comm,"   ");
         break;                                 //            
        }
      //--------------------------------------------------------- 7 --
      switch(Stop_Order)                           //   
        {
         case OP_BUYSTOP: 
            Text="StopBuy ";                 //   Buy
            break;                                  //  switch
         case OP_SELLSTOP:
            Text="StopSell ";                       //   Sell
         }
      Print("  ",Text," ",Comm," ",Ticket,".  ..");  
      bool Ans=OrderModify(Ticket,Price,StopLoss,Profit,0,Yellow);//  
      //--------------------------------------------------------- 8 --
      if (Ans==true)                            //  :)
        {
         Print ("  ",Text," ",Comm," ",Ticket);
         i--;
         break;                                 //       
        }
      //--------------------------------------------------------- 9 --     
      
      
      int Error=GetLastError();               //   :(
      switch(Error)                            //  
        {         
        
         case 146:Print("  .  ..");
            Sleep(500);                   //  
            RefreshRates();               //  
            continue;                     //  . 
        }
      switch(Error)                       //  
        {
         case 2 : Print(" .");
            break;                        //   switch
         case 5 : Print("   .");
            break;                        //   switch
         case 64: Print(" .");
            break;                        //   switch
         case 133:Print(" ");
            break;                        //   switch
         default: Print("  ",Error);//    
        }
      break;                                    //    
     }      
      
    return (Ticket);
   }
 //+------------------------------------------------------------------+
//|    stoploss                                                        |
//+------------------------------------------------------------------+
 int iModifyStopLoss( int ticket,string Symb, string Comm, double StopLoss,int Magic, int Bay_Sell)export
 { 
    bool Ans=false;
    string Text; 
    int i;
    int Order=-1;
  for( i=1; i<=OrdersTotal(); i++)         //   
      {
      if (OrderSelect(i-1,SELECT_BY_POS)==true) //   
        {                                      //  :
         //------------------------------------------------------ 3 --
         if (OrderMagicNumber()!= Magic)     continue;    //   
         if (OrderSymbol()     != Symb)      continue;    //   ..
         if (OrderComment()    != Comm)      continue;    //   
         if (OrderType()       != Bay_Sell)  continue;  
                        
         //------------------------------------------------------ 4 --
         Order=Bay_Sell;                     //   
         ticket=OrderTicket();                   //  
         double Lot=OrderLots();                  //  
         }                                        //         
      
                                                 //  .                                     
     
  //--------------------------------------------------------------- 6 --
   while(true)                                 //   .
     {
      if (Order==-1)                       //   
        {
         //Print(" ",Symb,Comm,"   ");
         break;                                 //            
        }
      //--------------------------------------------------------- 7 --
      switch(Bay_Sell)                           //   
        {
         case OP_BUY: 
            Text="Buy ";                 //   Buy
            break;                                  //  switch
         case OP_SELL:
            Text="Sell ";                       //   Sell
         }
      Print("  ",Text," ",Comm," ",ticket,".  .."); 
      
      if (OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)==true)
         {      
         Ans=OrderModify(OrderTicket(),OrderOpenPrice(),StopLoss,OrderTakeProfit(),0,Green);
         }
      else
      Print("OrderSelect()   - ",GetLastError());
      //--------------------------------------------------------- 8 --
      if (Ans==true)                            //  :)
        {
         Print ("  ",Text," ",Comm," ",ticket);         
         break;                                 //       
        }
      //--------------------------------------------------------- 9 --     
      
      
      int Error=GetLastError();               //   :(
      switch(Error)                            //  
        {         
        
         case 4 :Print("  . ...");
            while(RefreshRates()==false)  //   
            Sleep(500);                   //   
            continue;                     //  . 
         case 6 :Print("    . ...");
            while(RefreshRates()==false)  //   
            Sleep(500);                   //   
            continue;                     //  . 
         case 132 :Print(" . ...");
            while(RefreshRates()==false)  //   
            Sleep(1000);                   //   
            continue;                     //  .  
         case 137 :Print(" . ...");
            while(RefreshRates()==false)  //   
            Sleep(500);                   //   
            continue;                     //  .             
         case 129 :Print(" . ...");
            while(RefreshRates()==false)  //   
            Sleep(50);                   //   
            continue;
         case 135:Print(" .   ..");
            RefreshRates();               //  
            continue;                     //  . 
         case 138:Print(" .   ..");
            RefreshRates();               //  
            continue;
         case 136:Print(" .   ..");
            while(RefreshRates()==false)  //   
               Sleep(100);                  //   
            continue;                     //  . 
         case 146:Print("  .  ..");
            Sleep(500);                   //  
            RefreshRates();               //  
            continue;                     //  . 
         case ERR_TRADE_TIMEOUT :Print("    ");
            Sleep(50);
            RefreshRates();               //  
            continue;      
        }
      switch(Error)                       //  
        {
         case 2 : Print(" .");
            break;                        //   switch
         case 5 : Print("   .");
            break;                        //   switch
         case 64: Print(" .");
            break;                        //   switch
         case 133:Print(" ");
            break;                        //   switch
         default: Print("  ",Error);//    
        }
      break;                                    //    
     }      
   }    
    return (ticket);
   }  
 //===========================         ============================================= 
 
 double iProfit_calculate(string Symb,int digit, double profit) export
  {
  double iProfit=-1;
  if (Symb=="EURUSD"||Symb=="EURGBP"||Symb=="GBPUSD"||Symb=="NZDUSD"||Symb=="USDCHF"||Symb=="USDCAD"||Symb=="USDJPY"
      ||Symb=="EURUSDm"||Symb=="EURGBPm"||Symb=="GBPUSDm"||Symb=="NZDUSDm"||Symb=="USDCHFm"||Symb=="USDCADm")
      {
      switch(Digits)
            {
            case 3:iProfit=profit*10; break;             
            case 4:iProfit=profit; break;                   
            case 5:iProfit=profit*10;
            }
       } 
   if (Symb=="USDSEK"||Symb=="USDSEKm")
      {
      switch(Digits)
            {          
            case 4:iProfit=profit*7; break;                   
            case 5:iProfit=profit*70;
            }
      }    
           
  return (iProfit); 
  }
 //===========================         ====================================== 
 double iStoploss_calculate(string Symb,int digit, double stoploss) export
 {
  double iStoploss=-1;
  if (Symb=="EURUSD"||Symb=="EURGBP"||Symb=="GBPUSD"||Symb=="NZDUSD"||Symb=="USDCHF"||Symb=="USDCAD"||Symb=="USDJPY"
      ||Symb=="EURUSDm"||Symb=="EURGBPm"||Symb=="GBPUSDm"||Symb=="NZDUSDm"||Symb=="USDCHFm"||Symb=="USDCADm")
      {
      switch(Digits)
            {
            case 3:iStoploss=stoploss*0.01; break;            
            case 4:iStoploss=stoploss*0.0001; break;                   
            case 5:iStoploss=stoploss*0.0001;
            }
       } 
       
   if (Symb=="USDSEK"||Symb=="USDSEKm")
      {
      switch(Digits)
            {          
            case 4:iStoploss=stoploss*0.0007; break;                   
            case 5:iStoploss=stoploss*0.0007;
            }
      }           
  return (iStoploss); 
  }